//This is an abstract class of a generic object to draw.

#ifndef __DRAWOBJECT_H__
#define __DRAWOBJECT_H__

#include <FL/gl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>

using namespace std;

class DrawObject {
 public:
  ////////////////
  //Constructor //
  ////////////////
  DrawObject();

  //////////////
  //Mutators: //
  //////////////
  //move the object's center point in space
  void x(float);
  void y(float);
  void z(float);

  //change the size of the object
  void setWidth(float);
  void setHeight(float);

  //////////////
  //Getters:  //
  //////////////
  //get the object's center point in space
  float x(void);
  float y(void);
  float z(void);
  
  //get the size of the object
  float getWidth(void);
  float getHeight(void);

  //////////////
  // Events:  //
  //////////////
  virtual string onClick(int button, int x, int y) = 0;

  //////////////
  // The Rest://
  //////////////
  virtual void draw(void) = 0;

 protected:

 private:
  //the center point
  float centerx, centery, centerz;

  //the size
  float width, height;
};


#endif
